#property copyright "(c) 2012 by PapaYozh"
#property link      "*"

#property show_inputs
#property indicator_separate_window
#property indicator_buffers   8

#property indicator_style1    STYLE_SOLID
#property indicator_style2    STYLE_SOLID
#property indicator_style3    STYLE_SOLID
#property indicator_style4    STYLE_SOLID
#property indicator_style5    STYLE_SOLID
#property indicator_style6    STYLE_SOLID
#property indicator_style7    STYLE_SOLID
#property indicator_style8    STYLE_SOLID

#property indicator_color1    Blue
#property indicator_color2    Orange
#property indicator_color3    OliveDrab
#property indicator_color4    Pink
#property indicator_color5    Red
#property indicator_color6    Tan
#property indicator_color7    Green
#property indicator_color8    Gray

#property indicator_width1    1
#property indicator_width2    1
#property indicator_width3    1
#property indicator_width4    1
#property indicator_width5    1
#property indicator_width6    1
#property indicator_width7    1
#property indicator_width8    1

// --
//---- input parameters
extern bool    indxUSD  = false;
extern bool    indxEUR  = false;
extern bool    indxCHF  = false;
extern bool    indxGBP  = false;
extern bool    indxJPY  = false;
extern bool    indxCAD  = false;
extern bool    indxAUD  = false;
extern bool    indxNZD  = false;
extern bool    Normalize      = true;
extern int     HistoryDepth   = 500;
//
string   ShortName;
//---- buffers
double indx0[];
double indx1[];
double indx2[];
double indx3[];
double indx4[];
double indx5[];
double indx6[];
double indx7[];
//
string CurrensyName[8]={"USD","EUR","CHF","GBP","JPY","CAD","AUD","NZD"};
double indxStandard[8];
//
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   int   ii;
   int   err;
   string   IndShortName;
   
   IndicatorBuffers( 8 );
   
   err   = 0;
   if ( !SetIndexBuffer(0,indx0) ) err += 1;
   if ( !SetIndexBuffer(1,indx1) ) err += 1;
   if ( !SetIndexBuffer(2,indx2) ) err += 1;
   if ( !SetIndexBuffer(3,indx3) ) err += 1;
   if ( !SetIndexBuffer(4,indx4) ) err += 1;
   if ( !SetIndexBuffer(5,indx5) ) err += 1;
   if ( !SetIndexBuffer(6,indx6) ) err += 1;
   if ( !SetIndexBuffer(7,indx7) ) err += 1;
   
   IndShortName   = "";
   if ( err == 0 )
   {
      for( ii=0; ii<8; ii++ )
      {
         SetIndexEmptyValue(ii,EMPTY_VALUE);
         SetIndexStyle(ii,DRAW_LINE,EMPTY,EMPTY);
         indxStandard[ii]  = EMPTY_VALUE;
      }
      
      if ( indxUSD )
      {
         IndShortName   = StringConcatenate(IndShortName,":USD");
         SetIndexLabel(0,CurrensyName[0]);
      }
      else
         SetIndexLabel(0,NULL);
      if ( indxEUR )
      {
         IndShortName   = StringConcatenate(IndShortName,":EUR");
         SetIndexLabel(1,CurrensyName[1]);
      }
         else SetIndexLabel(1,NULL);
      if ( indxCHF )
      {
         IndShortName   = StringConcatenate(IndShortName,":CHF");
         SetIndexLabel(2,CurrensyName[2]);
      }
         else SetIndexLabel(2,NULL);
      if ( indxGBP )
      {
         IndShortName   = StringConcatenate(IndShortName,":GBP");
         SetIndexLabel(3,CurrensyName[3]);
      }
         else SetIndexLabel(3,NULL);
      if ( indxJPY )
      {
         IndShortName   = StringConcatenate(IndShortName,":JPY");
         SetIndexLabel(4,CurrensyName[4]);
      }
         else SetIndexLabel(4,NULL);
      if ( indxCAD )
      {
         IndShortName   = StringConcatenate(IndShortName,":CAD");
         SetIndexLabel(5,CurrensyName[5]);
      }
         else SetIndexLabel(5,NULL);
      if ( indxAUD )
      {
         IndShortName   = StringConcatenate(IndShortName,":AUD");
         SetIndexLabel(6,CurrensyName[6]);
      }
         else SetIndexLabel(6,NULL);
      if ( indxNZD )
      {
         IndShortName   = StringConcatenate(IndShortName,":NZD");
         SetIndexLabel(7,CurrensyName[7]);
      }
         else SetIndexLabel(7,NULL);
   }
   if ( StringSubstr(IndShortName,0,1) == ":" )
      IndShortName   = StringConcatenate(" (",StringSubstr(IndShortName,1,-1),")");
   
   if ( Normalize )
      IndShortName   = StringConcatenate(" norm.",IndShortName);
   IndShortName   = StringConcatenate("FX indexes",IndShortName);
   
   IndicatorShortName( IndShortName );

   return(err);
} // init()
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   return(0);
} // deinit()
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int      shift;
   int      ii;
   double   ProductOfIndexes;
   
   for( shift=Bars-IndicatorCounted(); shift>=0; shift-- )
   {
      if ( HistoryDepth > 0 && shift > HistoryDepth )
         continue;
      
      if ( indxUSD ) indx0[shift] = CalculateIndex(CurrensyName[0],shift); else indx0[shift] = EMPTY_VALUE;
      if ( indxEUR ) indx1[shift] = CalculateIndex(CurrensyName[1],shift); else indx1[shift] = EMPTY_VALUE;
      if ( indxCHF ) indx2[shift] = CalculateIndex(CurrensyName[2],shift); else indx2[shift] = EMPTY_VALUE;
      if ( indxGBP ) indx3[shift] = CalculateIndex(CurrensyName[3],shift); else indx3[shift] = EMPTY_VALUE;
      if ( indxJPY ) indx4[shift] = CalculateIndex(CurrensyName[4],shift); else indx4[shift] = EMPTY_VALUE;
      if ( indxCAD ) indx5[shift] = CalculateIndex(CurrensyName[5],shift); else indx5[shift] = EMPTY_VALUE;
      if ( indxAUD ) indx6[shift] = CalculateIndex(CurrensyName[6],shift); else indx6[shift] = EMPTY_VALUE;
      if ( indxNZD ) indx7[shift] = CalculateIndex(CurrensyName[7],shift); else indx7[shift] = EMPTY_VALUE;
      
      // 
      if ( Normalize )
      {
         if ( indxStandard[0] == EMPTY_VALUE ) if ( indx0[shift] > 0.0 ) indxStandard[0] = indx0[shift];
         if ( indxStandard[1] == EMPTY_VALUE ) if ( indx1[shift] > 0.0 ) indxStandard[1] = indx1[shift];
         if ( indxStandard[2] == EMPTY_VALUE ) if ( indx2[shift] > 0.0 ) indxStandard[2] = indx2[shift];
         if ( indxStandard[3] == EMPTY_VALUE ) if ( indx3[shift] > 0.0 ) indxStandard[3] = indx3[shift];
         if ( indxStandard[4] == EMPTY_VALUE ) if ( indx4[shift] > 0.0 ) indxStandard[4] = indx4[shift];
         if ( indxStandard[5] == EMPTY_VALUE ) if ( indx5[shift] > 0.0 ) indxStandard[5] = indx5[shift];
         if ( indxStandard[6] == EMPTY_VALUE ) if ( indx6[shift] > 0.0 ) indxStandard[6] = indx6[shift];
         if ( indxStandard[7] == EMPTY_VALUE ) if ( indx7[shift] > 0.0 ) indxStandard[7] = indx7[shift];
         
         if ( indxStandard[0] != EMPTY_VALUE && indx0[shift] != EMPTY_VALUE ) indx0[shift] /= indxStandard[0];
         if ( indxStandard[1] != EMPTY_VALUE && indx1[shift] != EMPTY_VALUE ) indx1[shift] /= indxStandard[1];
         if ( indxStandard[2] != EMPTY_VALUE && indx2[shift] != EMPTY_VALUE ) indx2[shift] /= indxStandard[2];
         if ( indxStandard[3] != EMPTY_VALUE && indx3[shift] != EMPTY_VALUE ) indx3[shift] /= indxStandard[3];
         if ( indxStandard[4] != EMPTY_VALUE && indx4[shift] != EMPTY_VALUE ) indx4[shift] /= indxStandard[4];
         if ( indxStandard[5] != EMPTY_VALUE && indx5[shift] != EMPTY_VALUE ) indx5[shift] /= indxStandard[5];
         if ( indxStandard[6] != EMPTY_VALUE && indx6[shift] != EMPTY_VALUE ) indx6[shift] /= indxStandard[6];
         if ( indxStandard[7] != EMPTY_VALUE && indx7[shift] != EMPTY_VALUE ) indx7[shift] /= indxStandard[7];
      }
   }
   
   return(0);
} // start()
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
double   CalculateIndex(string CurrName, int shift)
{
   int      ii,sh;
   double   res;
   double   opPrice;
   int      dir;
   string   Smbl,Smbl1,Smbl2;
   
   res   = 1.0;
   for( ii=0; ii<8 && res!=EMPTY_VALUE; ii++ )
   {
      if ( CurrName != CurrensyName[ii] )
      {
         opPrice  = 0.0;
         
         Smbl  = StringConcatenate(CurrName,CurrensyName[ii]);
         if ( MarketInfo(Smbl,MODE_TICKSIZE) > 0.0 )
            dir   = 1;
         else
         {
            Smbl  = StringConcatenate(CurrensyName[ii],CurrName);
            if ( MarketInfo(Smbl,MODE_TICKSIZE) > 0.0 )
               dir   = -1;
            else
            {  //    ,   USD
               Smbl1 = StringConcatenate(CurrName,"USD");
               if ( MarketInfo(Smbl1,MODE_TICKSIZE) > 0.0 )
               {
                  sh = iBarShift(Smbl1,0,Time[shift],true);
                  if ( sh < 0 )
                     opPrice  = EMPTY_VALUE;
                  else
                     opPrice  = iClose(Smbl1,0,sh) + ( MarketInfo(Smbl1,MODE_ASK) - MarketInfo(Smbl1,MODE_BID) ) / 2.0;
               }
               else
               {
                  Smbl1 = StringConcatenate("USD",CurrName);
                  if ( MarketInfo(Smbl1,MODE_TICKSIZE) > 0.0 )
                  {
                     sh = iBarShift(Smbl1,0,Time[shift],true);
                     if ( sh < 0 )
                        opPrice  = EMPTY_VALUE;
                     else
                        opPrice  = 1.0 / ( iClose(Smbl1,0,sh) + ( MarketInfo(Smbl1,MODE_ASK) - MarketInfo(Smbl1,MODE_BID) ) / 2.0 );
                  }
                  else
                     opPrice  = EMPTY_VALUE;
               }
               
               if ( opPrice != EMPTY_VALUE )
               {
                  Smbl2 = StringConcatenate("USD",CurrensyName[ii]);
                  if ( MarketInfo(Smbl2 ,MODE_TICKSIZE) > 0.0 )
                  {
                     sh = iBarShift(Smbl2,0,Time[shift],true);
                     if ( sh < 0 )
                        opPrice  = EMPTY_VALUE;
                     else
                        opPrice  *= iClose(Smbl2,0,sh) + ( MarketInfo(Smbl2,MODE_ASK) - MarketInfo(Smbl2,MODE_BID) ) / 2.0;
                  }
                  else
                  {
                     Smbl2 = StringConcatenate(CurrensyName[ii],"USD");
                     if ( MarketInfo(Smbl2,MODE_TICKSIZE) > 0.0 )
                     {
                        sh = iBarShift(Smbl2,0,Time[shift],true);
                        if ( sh < 0 )
                           opPrice  = EMPTY_VALUE;
                        else
                           opPrice  /= iClose(Smbl2,0,sh) + ( MarketInfo(Smbl2,MODE_ASK) - MarketInfo(Smbl2,MODE_BID) ) / 2.0;
                     }
                     else
                        opPrice  = EMPTY_VALUE;
                  }
               }
               
               if ( opPrice == EMPTY_VALUE )
               {
                  Smbl  = "";
                  dir   = 0;
               }
               else
               {
                  Smbl  = StringConcatenate(CurrName,CurrensyName[ii]);
                  dir   = 1;
               }
            }
         }
         
         if ( dir == 0 )
            res   = EMPTY_VALUE;
         else
         {
            if ( opPrice == 0.0 )
            {
               sh = iBarShift(Smbl,0,Time[shift],true);
               if ( sh < 0 )
                  dir   = 0;
               else
                  opPrice  = iClose(Smbl,0,sh) + ( MarketInfo(Smbl,MODE_ASK) - MarketInfo(Smbl,MODE_BID) ) / 2.0;
            }
            
            if ( dir == 1 )
               res   *= opPrice;
            else if ( dir == -1 )
               res   /= opPrice;
            else
               res   = EMPTY_VALUE;
         }
      }
   }
   
   if ( res > 0.0 && res != EMPTY_VALUE )
      return( MathPow( res, 1.0/8.0 ) );
   else
      return( EMPTY_VALUE );
   
} // CalculateIndex()
//+------------------------------------------------------------------+

